Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.cpp	(revision 104297)
@@ -123,5 +123,5 @@
 UIFileManager::UIFileManager(EmbedTo enmEmbedding, UIActionPool *pActionPool,
                              const CMachine &comMachine, QWidget *pParent, bool fShowToolbar)
-    : QIWithRetranslateUI<QWidget>(pParent)
+    : QWidget(pParent)
     , m_pMainLayout(0)
     , m_pVerticalSplitter(0)
@@ -141,5 +141,4 @@
     prepareObjects();
     prepareConnections();
-    retranslateUi();
     restorePanelVisibility();
     UIFileManagerOptions::create();
@@ -169,8 +168,4 @@
         return 0;
     return m_pActionPool->action(UIActionIndex_M_FileManager)->menu();
-}
-
-void UIFileManager::retranslateUi()
-{
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.h	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManager.h	(revision 104297)
@@ -40,5 +40,4 @@
 /* GUI includes: */
 #include "QIManagerDialog.h"
-#include "QIWithRetranslateUI.h"
 #include "UIGuestControlDefs.h"
 
@@ -88,5 +87,5 @@
  *  one host and one guest file table views, a log viewer
  *  and some other file manager related widgets. */
-class SHARED_LIBRARY_STUFF UIFileManager : public QIWithRetranslateUI<QWidget>
+class SHARED_LIBRARY_STUFF UIFileManager : public QWidget
 {
     Q_OBJECT;
@@ -109,8 +108,4 @@
 
     void setSelectedVMListItems(const QList<UIVirtualMachineItem*> &items);
-
-protected:
-
-    virtual void retranslateUi() RT_OVERRIDE;
 
 private slots:
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.cpp	(revision 104297)
@@ -39,4 +39,5 @@
 #include "UILoggingDefs.h"
 #include "UIShortcutPool.h"
+#include "UITranslationEventListener.h"
 #ifdef VBOX_WS_MAC
 # include "VBoxUtils-darwin.h"
@@ -78,5 +79,5 @@
                                          const QUuid &uMachineId,
                                          const QString &strMachineName)
-    : QIWithRetranslateUI<QIManagerDialog>(pCenterWidget)
+    : QIManagerDialog(pCenterWidget)
     , m_pActionPool(pActionPool)
     , m_uMachineId(uMachineId)
@@ -89,5 +90,5 @@
 }
 
-void UIFileManagerDialog::retranslateUi()
+void UIFileManagerDialog::sltRetranslateUI()
 {
     if (!m_strMachineName.isEmpty())
@@ -151,5 +152,7 @@
 {
     /* Apply language settings: */
-    retranslateUi();
+    sltRetranslateUI();
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+        this, &UIFileManagerDialog::sltRetranslateUI);
     manageEscapeShortCut();
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerDialog.h	(revision 104297)
@@ -38,6 +38,4 @@
 /* GUI includes: */
 #include "QIManagerDialog.h"
-#include "QIWithRetranslateUI.h"
-
 
 
@@ -69,5 +67,5 @@
 
 /** QIManagerDialog extension providing GUI with the dialog displaying file manager releated logs. */
-class UIFileManagerDialog : public QIWithRetranslateUI<QIManagerDialog>
+class UIFileManagerDialog : public QIManagerDialog
 {
     Q_OBJECT;
@@ -83,10 +81,4 @@
 
 protected:
-
-    /** @name Event-handling stuff.
-      * @{ */
-        /** Handles translation event. */
-        virtual void retranslateUi() RT_OVERRIDE;
-    /** @} */
 
     /** @name Prepare/cleanup cascade.
@@ -114,4 +106,9 @@
 
     void sltSetCloseButtonShortCut(QKeySequence shortcut);
+    /** @name Event-handling stuff.
+      * @{ */
+        /** Handles translation event. */
+        void sltRetranslateUI();
+    /** @} */
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerGuestTable.cpp	(revision 104297)
@@ -70,5 +70,5 @@
 /** A QWidget extension containing text entry fields for password and username and buttons to
   *  start/stop a guest session. */
-class UIGuestSessionWidget : public QIWithRetranslateUI<QWidget>
+class UIGuestSessionWidget : public QWidget
 {
     Q_OBJECT;
@@ -92,5 +92,4 @@
 protected:
 
-    void retranslateUi() RT_OVERRIDE;
     void keyPressEvent(QKeyEvent * pEvent) RT_OVERRIDE;
     void showEvent(QShowEvent *pEvent) RT_OVERRIDE;
@@ -98,4 +97,5 @@
 private slots:
 
+    void sltRetranslateUI();
     void sltButtonClick();
     void sltHandleTextChanged(const QString &strText);
@@ -129,5 +129,5 @@
 
 UIGuestSessionWidget::UIGuestSessionWidget(QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QWidget>(pParent)
+    : QWidget(pParent)
     , m_enmButtonMode(ButtonMode_Open)
     , m_pUserNameEdit(0)
@@ -187,5 +187,7 @@
     m_pMainLayout->insertStretch(-1, 1);
     switchSessionOpenMode();
-    retranslateUi();
+    sltRetranslateUI();
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIGuestSessionWidget::sltRetranslateUI);
 }
 
@@ -204,5 +206,5 @@
 }
 
-void UIGuestSessionWidget::retranslateUi()
+void UIGuestSessionWidget::sltRetranslateUI()
 {
     if (m_pUserNameEdit)
@@ -247,5 +249,5 @@
 void UIGuestSessionWidget::showEvent(QShowEvent *pEvent)
 {
-    QIWithRetranslateUI<QWidget>::showEvent(pEvent);
+    QWidget::showEvent(pEvent);
     if (m_pUserNameEdit)
         m_pUserNameEdit->setFocus();
@@ -259,5 +261,5 @@
         m_pPasswordEdit->setEnabled(true);
     m_enmButtonMode = ButtonMode_Open;
-    retranslateUi();
+    sltRetranslateUI();
 }
 
@@ -269,5 +271,5 @@
         m_pPasswordEdit->setEnabled(false);
     m_enmButtonMode = ButtonMode_Close;
-    retranslateUi();
+    sltRetranslateUI();
 }
 
@@ -448,5 +450,4 @@
 
     sltRetranslateUI();
-
     connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
             this, &UIFileManagerGuestTable::sltRetranslateUI);
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerPaneContainer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerPaneContainer.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIFileManagerPaneContainer.cpp	(revision 104297)
@@ -27,4 +27,5 @@
 
 /* Qt includes: */
+#include <QApplication>
 #include <QCheckBox>
 #include <QHBoxLayout>
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.cpp	(revision 104297)
@@ -39,4 +39,5 @@
 #include "UIMachine.h"
 #include "UISession.h"
+#include "UITranslationEventListener.h"
 
 
@@ -60,5 +61,5 @@
 
 UIGuestProcessControlDialog::UIGuestProcessControlDialog(QWidget *pCenterWidget)
-    : QIWithRetranslateUI<QIManagerDialog>(pCenterWidget)
+    : QIManagerDialog(pCenterWidget)
     , m_comGuest(gpMachine->uisession()->guest())
     , m_strMachineName(gpMachine->machineName())
@@ -66,5 +67,5 @@
 }
 
-void UIGuestProcessControlDialog::retranslateUi()
+void UIGuestProcessControlDialog::sltRetranslateUI()
 {
     /* Translate window title: */
@@ -103,5 +104,7 @@
 {
     /* Apply language settings: */
-    retranslateUi();
+    sltRetranslateUI();
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIGuestProcessControlDialog::sltRetranslateUI);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.h	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlDialog.h	(revision 104297)
@@ -37,5 +37,4 @@
 /* GUI includes: */
 #include "QIManagerDialog.h"
-#include "QIWithRetranslateUI.h"
 
 /* COM includes: */
@@ -58,5 +57,5 @@
 
 /** QIManagerDialog extension providing GUI with the dialog displaying guest control releated logs. */
-class UIGuestProcessControlDialog : public QIWithRetranslateUI<QIManagerDialog>
+class UIGuestProcessControlDialog : public QIManagerDialog
 {
     Q_OBJECT;
@@ -68,10 +67,4 @@
 
 protected:
-
-    /** @name Event-handling stuff.
-      * @{ */
-        /** Handles translation event. */
-        virtual void retranslateUi() RT_OVERRIDE;
-    /** @} */
 
     /** @name Prepare/cleanup cascade.
@@ -99,4 +92,9 @@
 
     void sltSetCloseButtonShortCut(QKeySequence shortcut);
+    /** @name Event-handling stuff.
+      * @{ */
+        /** Handles translation event. */
+        void sltRetranslateUI();
+    /** @} */
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.cpp	(revision 104297)
@@ -40,4 +40,5 @@
 #include "UIGuestProcessControlWidget.h"
 #include "UIIconPool.h"
+#include "UITranslationEventListener.h"
 
 /* COM includes: */
@@ -295,5 +296,5 @@
                                                          QWidget *pParent, QString strMachineName /* = QString()*/,
                                                          bool fShowToolbar /* = false */)
-    :QIWithRetranslateUI<QWidget>(pParent)
+    : QWidget(pParent)
     , m_comGuest(comGuest)
     , m_pMainLayout(0)
@@ -310,5 +311,7 @@
     prepareToolBar();
     initGuestSessionTree();
-    retranslateUi();
+    sltRetranslateUI();
+    connect(&translationEventListener(), &UITranslationEventListener::sigRetranslateUI,
+            this, &UIGuestProcessControlWidget::sltRetranslateUI);
 }
 
@@ -318,5 +321,5 @@
 }
 
-void UIGuestProcessControlWidget::retranslateUi()
+void UIGuestProcessControlWidget::sltRetranslateUI()
 {
     if (m_pTreeWidget)
Index: trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.h	(revision 104296)
+++ trunk/src/VBox/Frontends/VirtualBox/src/guestctrl/UIGuestProcessControlWidget.h	(revision 104297)
@@ -40,5 +40,4 @@
 
 /* GUI includes: */
-#include "QIWithRetranslateUI.h"
 #include "QIManagerDialog.h"
 #include "UIMainEventListener.h"
@@ -51,5 +50,5 @@
 /** QWidget extension
   * providing GUI with guest session information and control tab in session-information window. */
-class UIGuestProcessControlWidget : public QIWithRetranslateUI<QWidget>
+class UIGuestProcessControlWidget : public QWidget
 {
     Q_OBJECT;
@@ -63,10 +62,7 @@
     static const bool  s_fDeleteAfterUnregister;
 
-protected:
-
-    virtual void retranslateUi() RT_OVERRIDE;
-
 private slots:
 
+    void sltRetranslateUI();
     void sltGuestSessionsUpdated();
     void sltGuestSessionRegistered(CGuestSession guestSession);