Index: trunk/src/VBox/Additions/x11/VBoxClient/clipboard-x11.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/clipboard-x11.cpp	(revision 104316)
+++ trunk/src/VBox/Additions/x11/VBoxClient/clipboard-x11.cpp	(revision 104317)
@@ -85,6 +85,6 @@
             if (RT_SUCCESS(rc))
             {
-                rc = ShClTransferRootsInitFromStringListEx(pTransfer, (const char *)pvData, cbData,
-                                                           "\n" /* X11-based Desktop environments separate entries with "\n" */);
+                rc = ShClTransferRootsSetFromStringListEx(pTransfer, (const char *)pvData, cbData,
+                                                          "\n" /* X11-based Desktop environments separate entries with "\n" */);
                 RTMemFree(pvData);
             }
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 104316)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 104317)
@@ -1242,5 +1242,5 @@
          *         actually has some root entries set, as the other side can query for those at any time then. */
         if (pTransfer->State.enmDir == SHCLTRANSFERDIR_TO_REMOTE)
-            AssertMsgStmt(ShClTransferRootsCount(pTransfer), ("Transfer has no root entries set\n"), rc = VERR_WRONG_ORDER);
+            AssertMsgStmt(ShClTransferRootsCount(pTransfer), ("Transfer has no root entries set (yet)\n"), rc = VERR_WRONG_ORDER);
 
         if (RT_SUCCESS(rc))
@@ -1821,5 +1821,5 @@
 
 /**
- * Initializes the root list entries for a given clipboard transfer, extended version.
+ * Set the root list entries for a given clipboard transfer, extended version.
  *
  * @returns VBox status code.
@@ -1832,5 +1832,5 @@
  * @note    Accepts local paths or URI string lists (absolute only).
  */
-int ShClTransferRootsInitFromStringListEx(PSHCLTRANSFER pTransfer, const char *pszRoots, size_t cbRoots, const char *pszSep)
+int ShClTransferRootsSetFromStringListEx(PSHCLTRANSFER pTransfer, const char *pszRoots, size_t cbRoots, const char *pszSep)
 {
     AssertPtrReturn(pTransfer,      VERR_INVALID_POINTER);
@@ -1992,5 +1992,5 @@
 
 /**
- * Initializes the root list entries for a given clipboard transfer.
+ * Sets the root list entries for a given clipboard transfer.
  *
  * @returns VBox status code.
@@ -2002,11 +2002,11 @@
  * @note    Accepts local paths or URI string lists (absolute only).
  */
-int ShClTransferRootsInitFromStringList(PSHCLTRANSFER pTransfer, const char *pszRoots, size_t cbRoots)
-{
-    return ShClTransferRootsInitFromStringListEx(pTransfer, pszRoots, cbRoots, SHCL_TRANSFER_URI_LIST_SEP_STR);
-}
-
-/**
- * Initializes the root list entries for a given clipboard transfer, UTF-16 (Unicode) version.
+int ShClTransferRootsSetFromStringList(PSHCLTRANSFER pTransfer, const char *pszRoots, size_t cbRoots)
+{
+    return ShClTransferRootsSetFromStringListEx(pTransfer, pszRoots, cbRoots, SHCL_TRANSFER_URI_LIST_SEP_STR);
+}
+
+/**
+ * Sets the root list entries for a given clipboard transfer, UTF-16 (Unicode) version.
  *
  * @returns VBox status code.
@@ -2018,5 +2018,5 @@
  * @note    Accepts local paths or URI string lists (absolute only).
  */
-int ShClTransferRootsInitFromStringListUnicode(PSHCLTRANSFER pTransfer, PRTUTF16 pwszRoots, size_t cbRoots)
+int ShClTransferRootsSetFromStringListUnicode(PSHCLTRANSFER pTransfer, PRTUTF16 pwszRoots, size_t cbRoots)
 {
     AssertPtrReturn(pwszRoots, VERR_INVALID_POINTER);
@@ -2039,5 +2039,5 @@
             rc = ShClConvUtf16CRLFToUtf8LF(pwszRoots, cwcRoots, pszDst, chDst, &cbActual);
             if (RT_SUCCESS(rc))
-                rc = ShClTransferRootsInitFromStringList(pTransfer, pszDst, cbActual + 1 /* Include terminator */);
+                rc = ShClTransferRootsSetFromStringList(pTransfer, pszDst, cbActual + 1 /* Include terminator */);
 
             RTStrFree(pszDst);
@@ -2051,5 +2051,5 @@
 
 /**
- * Initializes a single path as a transfer root.
+ * Sets a single path as a transfer root.
  *
  * @returns VBox status code.
@@ -2059,5 +2059,5 @@
  * @note    Convenience function, uses ShClTransferRootsInitFromStringList() internally.
  */
-int ShClTransferRootsInitFromPath(PSHCLTRANSFER pTransfer, const char *pszPath)
+int ShClTransferRootsSetFromPath(PSHCLTRANSFER pTransfer, const char *pszPath)
 {
     AssertPtrReturn(pTransfer, VERR_INVALID_POINTER);
@@ -2069,5 +2069,5 @@
     rc = RTStrAAppend(&pszRoots, SHCL_TRANSFER_URI_LIST_SEP_STR);
     AssertRCReturn(rc, rc);
-    rc =  ShClTransferRootsInitFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1 /* Include terminator */);
+    rc =  ShClTransferRootsSetFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1 /* Include terminator */);
     RTStrFree(pszRoots);
     return rc;
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp	(revision 104316)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp	(revision 104317)
@@ -1317,5 +1317,5 @@
                 if (RT_SUCCESS(rc))
                 {
-                    rc = ShClTransferRootsInitFromStringList(pTransfer, pszList, cbList);
+                    rc = ShClTransferRootsSetFromStringList(pTransfer, pszList, cbList);
                     RTStrFree(pszList);
                 }
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp	(revision 104316)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp	(revision 104317)
@@ -106,5 +106,5 @@
     RTTEST_CHECK_RC_OK(hTest, ShClTransferCreate(SHCLTRANSFERDIR_TO_REMOTE, SHCLSOURCE_LOCAL, NULL /* Callbacks */, &pTx));
     RTTEST_CHECK_RC_OK(hTest, ShClTransferSetProvider(pTx, pProvider));
-    RTTEST_CHECK_RC_OK(hTest, ShClTransferRootsInitFromPath(pTx, pszPath));
+    RTTEST_CHECK_RC_OK(hTest, ShClTransferRootsSetFromPath(pTx, pszPath));
     RTTEST_CHECK_RC_OK(hTest, ShClTransferInit(pTx));
     RTTEST_CHECK_RC_OK(hTest, ShClTransferCtxRegister(pTransferCtx, pTx, NULL));
Index: trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 104316)
+++ trunk/src/VBox/HostServices/SharedClipboard/VBoxSharedClipboardSvc-x11.cpp	(revision 104317)
@@ -674,5 +674,5 @@
     if (RT_SUCCESS(rc))
     {
-        rc = ShClTransferRootsInitFromStringList(pCtx->pTransfer, (const char *)pvData, cbData);
+        rc = ShClTransferRootsSetFromStringList(pCtx->pTransfer, (const char *)pvData, cbData);
         if (RT_SUCCESS(rc))
             LogRel2(("Shared Clipboard: Host reported %RU64 X11 root entries for transfer to guest\n",
Index: trunk/src/VBox/HostServices/SharedClipboard/testcase/tstClipboardTransfers.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/testcase/tstClipboardTransfers.cpp	(revision 104316)
+++ trunk/src/VBox/HostServices/SharedClipboard/testcase/tstClipboardTransfers.cpp	(revision 104317)
@@ -231,5 +231,5 @@
     RTTESTI_CHECK_RC_OK_RETV(rc);
 
-    rc = ShClTransferRootsInitFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1);
+    rc = ShClTransferRootsSetFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1);
     RTTESTI_CHECK_RC(rc, rcExpected);
 
@@ -267,5 +267,5 @@
     RTTESTI_CHECK_RC_OK_RETV(rc);
 
-    rc = ShClTransferRootsInitFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1);
+    rc = ShClTransferRootsSetFromStringList(pTransfer, pszRoots, strlen(pszRoots) + 1);
     RTTESTI_CHECK_RC_OK(rc);
 