Index: trunk/src/VBox/Installer/win/NLS/de_DE.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/de_DE.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">Eine alte Sun Version von VirtualBox wurde auf diesem Computer gefunden. Bitte deinstallieren Sie diese Version zuerst. Danach können Sie [ProductName] installieren!</String>
     <String Id="InnotekFound">Eine alte innotek Version von VirtualBox wurde auf diesem Computer gefunden. Bitte deinstallieren Sie diese Version zuerst. Danach können Sie [ProductName] installieren!</String>
-    <String Id="InvalidTargetDir">Ungültiges Installationsverzeichnis angegeben. Bitte ein anderes Installationsverzeichnis wählen, um [ProductName] zu installieren.</String>
+    <String Id="InvalidTargetDir">Ungültiges Installationsverzeichnis angegeben. Bitte ein anderes Installationsverzeichnis wählen, um [ProductName] zu installieren. Für mehr Informationen bitte im [ProductName] Handbuch nachschlagen.</String>
 
     <!---->
@@ -95,5 +95,5 @@
     <!---->
     <String Id="InvalidTargetDirDlg_Header">Ungültiges Installationsverzeichnis</String>
-    <String Id="InvalidTargetDirDlg_Desc1">Das gewählte Installationsverzeichnis is ungültig, da dieses nicht den Sicherheitsrichtlinien entspricht.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">Das gewählte Installationsverzeichnis is ungültig, da dieses nicht den Sicherheitsrichtlinien entspricht. Für mehr Informationen bitte im [ProductName] Handbuch nachschlagen.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Bitte ein anderes Installationsverzeichnis wählen um [ProductName] zu installieren.</String>
 
Index: trunk/src/VBox/Installer/win/NLS/el_GR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/el_GR.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">Βρέθηκε μία παλιότερη εγκατάσταση του Sun VirtualBox στον υπολογιστή. Καταργήστε πρώτα την εγκατάσταση αυτού του πακέτου και μετά εγκαταστήστε το [ProductName]!</String>
     <String Id="InnotekFound">Βρέθηκε μία παλιότερη εγκατάσταση του innotek VirtualBox στον υπολογιστή. Καταργήστε πρώτα την εγκατάσταση αυτού του πακέτου και μετά εγκαταστήστε το [ProductName]!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -96,5 +96,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/en_US.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/en_US.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">An old Sun VirtualBox installation has been found on this machine. Please uninstall this package first and then install [ProductName]!</String>
     <String Id="InnotekFound">An old innotek VirtualBox installation has been found on this machine. Please uninstall this package first and then install [ProductName]!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -96,5 +96,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/fa_IR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/fa_IR.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/fa_IR.wxl	(revision 104410)
@@ -68,5 +68,5 @@
     <String Id="SunFound">یک نصب قدیمی ویرچوال باکس روی این رایانه یافت شد. لطفا اول این بسته را حذف سپس [ProductName] را نصب کنید!</String>
     <String Id="InnotekFound">یک نسخه قدیمی نصب ویرچوال باکس در این ماشین یافت شد. لطفا اول این بسته را حذف و سپس [ProductName] را نصب کنید!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
     <!---->
     <String Id="CancelDlg_Question">آیا میخواهید نصب [ProductName] را لغو کنید؟</String>
@@ -81,5 +81,5 @@
     <!---->
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
     <!---->
Index: trunk/src/VBox/Installer/win/NLS/fr_FR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/fr_FR.wxl	(revision 104410)
@@ -74,5 +74,5 @@
     <String Id="Only64Bit">Cette application ne marche que sur des systèmes Windows 64-bit. Veuillez installer la version 32-bit de [ProductName]!</String>
     <String Id="InnotekFound">Vous avez une ancienne installation de innotek VirtualBox sur cette machine. Il vous faudra la désinstaller avant de pouvoir installer [ProductName].</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -95,5 +95,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/it_IT.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/it_IT.wxl	(revision 104410)
@@ -68,5 +68,5 @@
     <String Id="SunFound">Una vecchia installazione di Sun VirtualBox è stata trovata su questa macchina. Disinstalla prima questo pacchetto e poi installa [ProductName]!</String>
     <String Id="InnotekFound">Una vecchia installazione di innotek VirtualBox è stata trovata su questa macchina. Disinstalla prima questo pacchetto e poi installa [ProductName]!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
     <!---->
     <String Id="CancelDlg_Question">Sei sicuro di voler annullare l'installazione di [ProductName]?</String>
@@ -81,5 +81,5 @@
     <!---->
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
     <!---->
Index: trunk/src/VBox/Installer/win/NLS/ru_RU.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/ru_RU.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">An old Sun VirtualBox installation has been found on this machine. Please uninstall this package first and then install [ProductName]!</String>
     <String Id="InnotekFound">An old innotek VirtualBox installation has been found on this machine. Please uninstall this package first and then install [ProductName]!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -96,5 +96,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/tr_TR.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/tr_TR.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">Bu makinede eski bir Sun VirtualBox kurulumu bulundu. Lütfen önce bu paketi kaldırın ve sonra [ProductName] yükleyin!</String>
     <String Id="InnotekFound">Bu makinede eski bir innotek VirtualBox kurulumu bulundu. Lütfen önce bu paketi kaldırın ve sonra [ProductName] yükleyin!</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -96,5 +96,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/zh_CN.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/zh_CN.wxl	(revision 104410)
@@ -75,5 +75,5 @@
 <String Id="SunFound">在此计算机发现旧的 Sun VirtualBox 安装。 请先卸载此组件然后安装 [ProductName]！</String>
 <String Id="InnotekFound">在此计算机发现旧的 innotek VirtualBox 安装。 请先卸载此组件然后安装 [ProductName]！</String>
-<String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+<String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
 <!---->
@@ -96,5 +96,5 @@
 
 <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-<String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+<String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
 <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/NLS/zh_TW.wxl
===================================================================
--- trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 104266)
+++ trunk/src/VBox/Installer/win/NLS/zh_TW.wxl	(revision 104410)
@@ -75,5 +75,5 @@
     <String Id="SunFound">在此電腦發現舊的 Sun VirtualBox 安裝。 請先解除安裝此套件然後安裝 [ProductName]！</String>
     <String Id="InnotekFound">在此電腦發現舊的 innotek VirtualBox 安裝。 請先解除安裝此套件然後安裝 [ProductName]！</String>
-    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName].</String>
+    <String Id="InvalidTargetDir">Invalid installation directory specified! Please use another installation directory to install [ProductName]. Refer to the [ProductName] manual for more information.</String>
 
     <!---->
@@ -96,5 +96,5 @@
 
     <String Id="InvalidTargetDirDlg_Header">Invalid installation directory</String>
-    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements.</String>
+    <String Id="InvalidTargetDirDlg_Desc1">The chosen installation directory is invalid, as it does not meet the security requirements. Refer to the [ProductName] manual for more information.</String>
     <String Id="InvalidTargetDirDlg_Desc2">Please choose another directory for installing [ProductName].</String>
 
Index: trunk/src/VBox/Installer/win/UserInterface.wxi
===================================================================
--- trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 104266)
+++ trunk/src/VBox/Installer/win/UserInterface.wxi	(revision 104410)
@@ -223,5 +223,5 @@
             </Control>
 
-            <Control Id="Description2" Type="Text" X="135" Y="95" Width="220" Height="130" Transparent="yes" NoPrefix="yes">
+            <Control Id="Description2" Type="Text" X="135" Y="105" Width="220" Height="130" Transparent="yes" NoPrefix="yes">
                 <Text>!(loc.InvalidTargetDirDlg_Desc2)</Text>
             </Control>