Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 104463)
@@ -1435,5 +1435,5 @@
 }
 
-void UIVMActivityMonitorLocal::sltGuestAdditionsStateChange()
+void UIVMActivityMonitorLocal::guestAdditionsStateChange()
 {
     bool fGuestAdditionsAvailable = guestAdditionsAvailable("6.1");
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h	(revision 104463)
@@ -257,11 +257,5 @@
     virtual QUuid machineId() const RT_OVERRIDE;
     virtual QString machineName() const RT_OVERRIDE;
-
-public slots:
-
-    /** @name These functions are connected to API events and implement necessary updates.
-     * @{ */
-        void sltGuestAdditionsStateChange();
-    /** @} */
+    void guestAdditionsStateChange();
 
 protected slots:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.cpp	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.cpp	(revision 104463)
@@ -348,2 +348,14 @@
     m_pPaneContainer->setVisible(fChecked);
 }
+
+void UIVMActivityMonitorContainer::guestAdditionsStateChange(const QUuid &machineId)
+{
+    for (int i = m_pTabWidget->count() - 1; i >= 0; --i)
+    {
+        UIVMActivityMonitorLocal *pMonitor = qobject_cast<UIVMActivityMonitorLocal*>(m_pTabWidget->widget(i));
+        if (!pMonitor)
+            continue;
+        if (pMonitor->machineId() == machineId)
+            pMonitor->guestAdditionsStateChange();
+    }
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.h	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitorContainer.h	(revision 104463)
@@ -101,4 +101,5 @@
     void addLocalMachine(const CMachine &comMachine);
     void addCloudMachine(const CCloudMachine &comMachine);
+    void guestAdditionsStateChange(const QUuid &machineId);
 
 private slots:
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 104463)
@@ -150,4 +150,15 @@
 }
 
+void UIVMInformationDialog::sltAdditionsStateChange()
+{
+    if (!m_pTabWidget)
+        return;
+    UIVMActivityMonitorContainer *pVMActivityMonitorContainer =
+        qobject_cast<UIVMActivityMonitorContainer*>(m_pTabWidget->widget(Tabs_ActivityMonitor));
+    if (!pVMActivityMonitorContainer)
+        return;
+    pVMActivityMonitorContainer->guestAdditionsStateChange(uiCommon().managedVMUuid());
+}
+
 void UIVMInformationDialog::saveDialogGeometry()
 {
@@ -160,4 +171,6 @@
 void UIVMInformationDialog::prepare()
 {
+    connect(gpMachine, &UIMachine::sigAdditionsStateChange,
+            this, &UIVMInformationDialog::sltAdditionsStateChange);
 #ifndef VBOX_WS_MAC
     /* Assign window icon: */
@@ -228,7 +241,4 @@
         /* Create Activity Monitor tab: */
         UIVMActivityMonitorContainer *pVMActivityMonitorContainer = new UIVMActivityMonitorContainer(this, m_pActionPool, EmbedTo_Dialog);
-
-        // UIVMActivityMonitorLocal *pVMActivityMonitorWidget =
-        //     new UIVMActivityMonitorLocal(EmbedTo_Dialog, this, gpMachine->uisession()->machine());
         if (pVMActivityMonitorContainer)
         {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h	(revision 104462)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.h	(revision 104463)
@@ -80,6 +80,8 @@
     void sltHandlePageChanged(int iIndex);
     void sltMachineStateChange(const QUuid &uMachineId, const KMachineState state);
+    void sltAdditionsStateChange();
 
 private:
+
     enum Tabs
     {