Index: trunk/src/libs/xpcom18a4/xpcom/tests/TestAutoLock.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/tests/TestAutoLock.cpp	(revision 103505)
+++ trunk/src/libs/xpcom18a4/xpcom/tests/TestAutoLock.cpp	(revision 104482)
@@ -93,4 +93,6 @@
     vrc = RTThreadCreate(&hThread, run, NULL, 0 /*cbStack*/,
                          RTTHREADTYPE_IO, RTTHREADFLAGS_WAITABLE, "AutoLockTest");
+    if (RT_FAILURE(vrc))
+        return RTEXITCODE_FAILURE;
 
     // ...and now do the same thing ourselves
Index: trunk/src/libs/xpcom18a4/xpcom/tests/TestObserverService.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/tests/TestObserverService.cpp	(revision 103505)
+++ trunk/src/libs/xpcom18a4/xpcom/tests/TestObserverService.cpp	(revision 104482)
@@ -127,9 +127,7 @@
                                                  NS_GET_IID(nsIObserverService),
                                                 (void **) &anObserverService);
-#ifdef VBOX
+
     bool fSuccess = res == NS_OK;
-#endif
-	
-    if (res == NS_OK) {
+    if (fSuccess) {
 
         nsIObserver *aObserver = new TestObserver(NS_LITERAL_STRING("Observer-A"));
@@ -140,22 +138,13 @@
         printf("Adding Observer-A as observer of topic-A...\n");
         rv = anObserverService->AddObserver(aObserver, topicA.get(), PR_FALSE);
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = testResult(rv);
  
         printf("Adding Observer-B as observer of topic-A...\n");
         rv = anObserverService->AddObserver(bObserver, topicA.get(), PR_FALSE);
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
  
         printf("Adding Observer-B as observer of topic-B...\n");
         rv = anObserverService->AddObserver(bObserver, topicB.get(), PR_FALSE);
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
 
         printf("Testing Notify(observer-A, topic-A)...\n");
@@ -163,8 +152,5 @@
                                    topicA.get(),
                                    NS_LITERAL_STRING("Testing Notify(observer-A, topic-A)").get() );
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
 
         printf("Testing Notify(observer-B, topic-B)...\n");
@@ -172,17 +158,10 @@
                                    topicB.get(),
                                    NS_LITERAL_STRING("Testing Notify(observer-B, topic-B)").get() );
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
  
         printf("Testing EnumerateObserverList (for topic-A)...\n");
         nsCOMPtr<nsISimpleEnumerator> e;
         rv = anObserverService->EnumerateObservers(topicA.get(), getter_AddRefs(e));
-
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
 
         printf("Enumerating observers of topic-A...\n");
@@ -200,8 +179,5 @@
                                       topicA.get(), 
                                       NS_LITERAL_STRING("during enumeration").get() );
-#ifdef VBOX
-              fSuccess = fSuccess &&
-#endif
-              testResult(rv);
+              fSuccess = fSuccess && testResult(rv);
           }
         }
@@ -210,24 +186,14 @@
         printf("Removing Observer-A...\n");
         rv = anObserverService->RemoveObserver(aObserver, topicA.get());
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
 
 
         printf("Removing Observer-B (topic-A)...\n");
         rv = anObserverService->RemoveObserver(bObserver, topicB.get());
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
+        fSuccess = fSuccess && testResult(rv);
         printf("Removing Observer-B (topic-B)...\n");
         rv = anObserverService->RemoveObserver(bObserver, topicA.get());
-#ifdef VBOX
-        fSuccess = fSuccess &&
-#endif
-        testResult(rv);
-
-#ifdef VBOX
+        fSuccess = fSuccess && testResult(rv);
+
         /* Cleanup: */
         nsrefcnt refs = bObserver->Release();
@@ -240,10 +206,6 @@
         if (refs != 0)
             printf("aObserver->Release() -> %d, expected 0\n", (int)refs);
-#endif
-    }
-#ifdef VBOX
+    }
+
     return fSuccess ? 0 : 1;
-#else
-    return NS_OK;
-#endif
-}
+}
Index: trunk/src/libs/xpcom18a4/xpcom/tests/TestStrings.cpp
===================================================================
--- trunk/src/libs/xpcom18a4/xpcom/tests/TestStrings.cpp	(revision 103505)
+++ trunk/src/libs/xpcom18a4/xpcom/tests/TestStrings.cpp	(revision 104482)
@@ -72,7 +72,5 @@
     nsAutoString buf(aStr);
 
-    PRInt32 n = buf.FindChar(',');
-
-    n = buf.Length();
+    PRInt32 n = buf.Length();
 
     buf.Cut(0, n + 1);